#ifndef _MEMALLOC_H_
#define _MEMALLOC_H_

ART   *AllocART   (const char *from, const char *subject);
NODE  *AllocNODE  (const char *name, const int len);
GLIST *AllocGLIST (const char *in_group, const char *in_header);

#ifdef SLOW

void FreeART  (ART *ap);
void FreeNODE (NODE *node);

#else

#define FreeART(ap)     free (ap)
#define FreeNODE(node)  free (node)

#endif

void  FreeListNode (LIST *list);

#if 0
/* DEBUG SUPPORT */
void *grn_malloc (const char *str, const long size);
#endif

#endif
