#include	"defs.h"

/************************************************************************/

void	SortArticlesByNumber(LIST *list) {
	LIST	tmp;
	ART	*np, *np2, *np3;
	UWORD	ndx = 0;

	if (EmptyList(list)) return;
	NewList(&tmp);
	while (!EmptyList(list)) {
		np = (ART *)RemHead(list);
		if (EmptyList(&tmp)) {
			AddHead(&tmp, (NODE *)np);
		}
		else {
			np2 = (ART *)tmp.lh_Head;
			np3 = (ART *)tmp.lh_TailPred;
			if (np->filenum < np2->filenum) {
				AddHead(&tmp, (NODE *)np);
			}
			else if (np->filenum > np3->filenum) {
				AddTail(&tmp, (NODE *)np);
			}
			else {
				for (; np2->node.ln_Succ; np2=(ART *)np2->node.ln_Succ) {
					if (np->filenum < np2->filenum) {
						Insert(&tmp, (NODE *)np, np2->node.ln_Pred);
						break;
					}
				}
			}
		}
		
	}
	NewList(list);
	while (!EmptyList(&tmp)) {
		np = (ART *)RemHead(&tmp);
		np->index = ndx++;
		AddTail(list, (NODE *)np);
	}
}

void	SortArticlesByState(LIST *list) {
	LIST	tmp;
	ART	*np, *np2, *np3;
	UWORD	ndx = 0;

	if (EmptyList(list)) return;
	NewList(&tmp);
	while (!EmptyList(list)) {
		np = (ART *)RemHead(list);
		if (EmptyList(&tmp)) {
			AddHead(&tmp, (NODE *)np);
		}
		else {
			np2 = (ART *)tmp.lh_Head;
			np3 = (ART *)tmp.lh_TailPred;
			if (np->state < np2->state) {
				AddHead(&tmp, (NODE *)np);
			}
			else if (np->state > np3->state) {
				AddTail(&tmp, (NODE *)np);
			}
			else {
				for (; np2->node.ln_Succ; np2=(ART *)np2->node.ln_Succ) {
					if (np->state < np2->state) {
						Insert(&tmp, (NODE *)np, np2->node.ln_Pred);
						break;
					}
				}
			}
		}
		
	}
	NewList(list);
	while (!EmptyList(&tmp)) {
		np = (ART *)RemHead(&tmp);
		np->index = ndx++;
		AddTail(list, (NODE *)np);
	}
}

void	SortArticlesByFrom(LIST *list) {
	LIST	tmp;
	ART	*np, *np2, *np3;
	UWORD	ndx = 0;

	if (EmptyList(list)) return;
	NewList(&tmp);
	while (!EmptyList(list)) {
		np = (ART *)RemHead(list);
		if (EmptyList(&tmp)) {
			AddHead(&tmp, (NODE *)np);
		}
		else {
			np2 = (ART *)tmp.lh_Head;
			np3 = (ART *)tmp.lh_TailPred;
			if (strcmp(np->from, np2->from) < 0) {
				AddHead(&tmp, (NODE *)np);
			}
			else if (strcmp(np->from, np3->from) > 0) {
				AddTail(&tmp, (NODE *)np);
			}
			else {
				for (; np2->node.ln_Succ; np2=(ART *)np2->node.ln_Succ) {
					if (strcmp(np->from, np2->from) < 0) {
						Insert(&tmp, (NODE *)np, np2->node.ln_Pred);
						break;
					}
				}
			}
		}
		
	}
	NewList(list);
	while (!EmptyList(&tmp)) {
		np = (ART *)RemHead(&tmp);
		np->index = ndx++;
		AddTail(list, (NODE *)np);
	}
}

void	SortArticlesBySubject(LIST *list) {
	LIST	tmp;
	ART	*np, *np2, *np3;
	UWORD	ndx = 0;

	if (EmptyList(list)) return;
	NewList(&tmp);
	while (!EmptyList(list)) {
		np = (ART *)RemHead(list);
		if (EmptyList(&tmp)) {
			AddHead(&tmp, (NODE *)np);
		}
		else {
			np2 = (ART *)tmp.lh_Head;
			np3 = (ART *)tmp.lh_TailPred;
			if (strcmp(np->subject, np2->subject) < 0) {
				AddHead(&tmp, (NODE *)np);
			}
			else if (strcmp(np->subject, np3->subject) > 0) {
				AddTail(&tmp, (NODE *)np);
			}
			else {
				for (; np2->node.ln_Succ; np2=(ART *)np2->node.ln_Succ) {
					if (strcmp(np->subject, np2->subject) < 0) {
						Insert(&tmp, (NODE *)np, np2->node.ln_Pred);
						break;
					}
				}
			}
		}
		
	}
	NewList(list);
	while (!EmptyList(&tmp)) {
		np = (ART *)RemHead(&tmp);
		np->index = ndx++;
		AddTail(list, (NODE *)np);
	}
}

